/*
 * Copyright (C) 2011, Texas Instruments, Incorporated
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __ASM_ARCH_GPIO_H
#define __ASM_ARCH_GPIO_H

#ifndef __ASSEMBLY__
void gpio_direction_output(int bank, int gpio, int en);
void gpio_direction_input(int bank, int gpio);
void gpio_set_value(int bank, int gpio, int value);
unsigned int gpio_get_value(int bank, int gpio);
#endif

#define GPIO_BANK0				0
#define GPIO_BANK1				1
#define GPIO_BANK2				2

#define	GPIO_REVISION				0x0
#define	GPIO_SYSCONFIG				0x10
#define	GPIO_EOI					0x20
#define	GPIO_IRQSTATUS_RAW_0		0x24
#define	GPIO_IRQSTATUS_RAW_1		0x28
#define	GPIO_IRQSTATUS_0			0x2C
#define	GPIO_IRQSTATUS_1			0x30
#define	GPIO_IRQSTATUS_SET_0		0x34
#define	GPIO_IRQSTATUS_SET_1		0x38
#define	GPIO_IRQSTATUS_CLR_0		0x3C
#define	GPIO_IRQSTATUS_CLR_1		0x40
#define GPIO_IRQWAKEN_0				0x44
#define GPIO_IRQWAKEN_1				0x48
#define	GPIO_SYSSTATUS				0x114
#define	GPIO_CTRL					0x130
#define	GPIO_OE						0x134
#define	GPIO_DATAIN					0x138
#define	GPIO_DATAOUT				0x13C
#define	GPIO_LEVELDETECT0			0x140
#define	GPIO_LEVELDETECT1			0x144
#define	GPIO_RISINGDETECT			0x148
#define	GPIO_FALLINGDETECT			0x14C
#define	GPIO_DEBOUNCENABLE			0x150
#define	GPIO_DEBOUNCINGTIME			0x154
#define	GPIO_CLEARDATAOUT			0x190
#define	GPIO_SETDATAOUT				0x194

/* Pin configurations */
#define GPIO_INPUT					0x0
#define GPIO_OUTPUT					0x1

#endif
